SystemOrganization addCategory: #'XML-Parser-GTExtensions'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting-Parser'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLDocument class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDOMParser parse: '<document><a></a><b></b></document>'! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:19'!
addTreeViewChildrenTo: aSequenceableCollection
	self hasDoctypeDeclaration
		ifTrue: [aSequenceableCollection addLast: self doctypeDeclaration].
	super addTreeViewChildrenTo: aSequenceableCollection.! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/6/2017 10:06'!
newSourceEditorTextStylerDecorator
	^ GLMXMLDocumentHighlighterTextStylerDecorator new! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/6/2017 20:31'!
outerXMLFromEditedSource: aString
	| newDocument |

	[newDocument :=
		(self parserHandlerClass on: aString)
			configuration: self configuration;
			parseDocument]
		on: Error
		do: [:error |
			newDocument := nil.
			error pass].
	newDocument
		ifNotNil: [
			self
				version: newDocument version;
				encoding: newDocument encoding;
				isStandalone: newDocument isStandalone;
				doctypeDeclaration: newDocument doctypeDeclaration;
				doctypeDefinition: newDocument doctypeDefinition;
				removeNodes;
				addNodes: newDocument nodes copy].
	^ self.! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:12'!
requiresTreeView
	^ self hasDoctypeDeclaration
		or: [super requiresTreeView]! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ true! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:02'!
writeTreeViewLabelXMLOn: aWriter
	self writeXMLDeclarationOn: aWriter! !

!XMLElement class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode firstElement! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 16:48'!
formForImageEntity: imageEntity
  | imageType parserClassName parserClass parser |
  imageType := imageEntity contentType sub.
  parserClassName := imageType asUppercase, #ReadWriter.
  parserClass := Smalltalk globals at: parserClassName asSymbol.
  parser := parserClass on: imageEntity readStream.
    ^ parser nextImage! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/2/2015 06:09'!
gtInspectorImageIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 40>
	| client url |
	aGTInspector panes size > 1
		ifFalse: [ ^ self ].
	client := (aGTInspector panes reversed collect: [ :each | (each port: #entity) value ])
		detect: [ :each | (each isKindOf: ZnClient) and: [ each request notNil ] ]
		ifNone: [ ^ self ].
	url := client request absoluteUrl.
	^ composite morph
		title: 'Image';
		display:
				[ self
				formForImageEntity:
					(ZnClient new
						beOneShot;
						get: url / (self attributeAt: 'src');
						entity) ];
		when: [ (self isNamed: 'img') and: [ self includesAttribute: 'src' ] ]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ self hasParent! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:26'!
writeTreeViewLabelXMLOn: aWriter
	self requiresTreeView
		ifTrue: [
			aWriter startTag
				name: self name;
				"uses setAttributes: for performance"
				setAttributes: attributes]
		ifFalse: [| tagWriter |
			(tagWriter := aWriter tag)
				name: self name;
				"uses setAttributes: for performance"
				setAttributes: attributes.
			self hasChildren
				ifTrue: [
					tagWriter with: [
						self writeInnerXMLOn: aWriter]]].! !

!XMLNode class methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 10/6/2015 10:47'!
gtExampleNodeWithParent
	<gtExample>
	^ self new parent: self new! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 22:15'!
asHighlightedText
	^ self asHighlightedTextWrittenWith: [:writer |
		self writeXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 22:42'!
asHighlightedTextWrittenWith: aBlock
	| writer |

	writer := XMLHighlightingWriter new.
	self escapesContentEntitiesWhenWriting
		ifFalse: [writer escapesContentEntityReferences: false].
	aBlock value: writer.
	^ writer asHighlightedText.! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/8/2017 10:22'!
gtInspectorSourceIn: aComposite
	<gtInspectorPresentationOrder: 6>

	aComposite custom:
		(self supportsSourceEditing
			ifTrue: [
				GLMRubricHighlightedTextPresentation new
					title: 'Source';
					editingMode: [
						GLMHighlighterTextRubEditingMode withStylerDecorator:
							self newSourceEditorTextStylerDecorator];
					display: [self asHighlightedText];
					withLineNumbers: true;
					act: [:presentation |
						| newOuterXMLNode currentPane browser |
						newOuterXMLNode :=
							self outerXMLFromEditedSource:
								presentation text asString.
						currentPane := aComposite pane.
						browser := currentPane browser.
						(browser panes copyUpTo: currentPane)
							ifEmpty: [
								"no previous panes; change the first pane to inspect
								newOuterXMLNode somehow (this does not work)"
								browser selection: newOuterXMLNode]
							ifNotEmpty: [:previousPanes |
								previousPanes do: [:each | each update].
								previousPanes last presentations first
									selection: newOuterXMLNode]]
						icon: GLMUIThemeExtraIcons glamorousAccept
						on: $s
						entitled: 'Save']
			ifFalse: [
				GLMXMLDisabledRubricHighlightedTextPresentation new
					title: 'Source';
					editingMode: [
						GLMHighlighterTextRubEditingMode withStylerDecorator:
							(GLMXMLDisabledDocumentHighlighterTextStylerDecorator
								disabledText: self asHighlightedText)];
					display: [self asHighlightedText];
					withLineNumbers: true])! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 22:14'!
gtInspectorTreeIn: aComposite
	<gtInspectorPresentationOrder: 5>

	^ aComposite tree
		title: 'Tree';
		display: [ {self} ];
		children: #treeViewChildren;
		format: #treeViewLabelText;
		when: [self requiresTreeView];
		rootsExpanded! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/5/2017 16:14'!
newSourceEditorTextStylerDecorator
	^ GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator outerXMLNode: self! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/8/2017 10:48'!
outerXMLFromEditedSource: aString
	| oldParent oldPosition oldSize |

	oldParent := self parent.
	oldPosition := oldParent nodes indexOf: self.
	oldSize := oldParent nodes size.
	oldParent
		outerXML: aString
		forNode: self.
	^ oldParent nodes size = oldSize
		ifTrue: [oldParent nodes at: oldPosition]
		ifFalse: [oldParent].! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:21'!
requiresTreeView
	"returns true if this node needs a tree view tab when inspected"
	^ false! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:30'!
supportsSourceEditing
	^ self hasParent
		and: [self parent isDocument not]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:21'!
treeViewChildren
	"returns the subnodes of this node in a tree view"
	^ #()! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/3/2016 17:40'!
treeViewLabelText
	"the label Text of this node to be used in a tree view"
	^ self asHighlightedTextWrittenWith: [:writer |
		self writeTreeViewLabelXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:02'!
writeTreeViewLabelXMLOn: aWriter
	self writeXMLOn: aWriter! !

!XMLAttributeList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/13/2015 13:19'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Attributes'
		columnTitle: 'Attribute'! !

!XMLNodeList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/13/2015 13:19'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Nodes'
		columnTitle: 'Node'! !

SAXParserDriver subclass: #SAXPositionParserDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!SAXPositionParserDriver commentStamp: 'monty 3/6/2016 08:19' prior: 0!
This class is a SAX driver that forwards token start/end positions to a SAXHandler. Does not support entities or validation, but does support namespaces.!

!SAXPositionParserDriver methodsFor: 'testing' stamp: 'monty 9/30/2015 03:50'!
decodesCharacters
	^ false! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
handleEndCDataPosition: aPosition
	self saxHandler endCDataPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleEndCommentPosition: aPosition
	self saxHandler endCommentPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:45'!
handleEndDeclaration: aPosition
	self saxHandler endDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
handleEndDoctypeDeclarationPosition: aPosition
	self saxHandler endDoctypeDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
handleEndEntityReferencePosition: aPosition
	self saxHandler endEntityReferencePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleEndPIPosition: aPosition
	self saxHandler endPIPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleEndQuotedStringValuePosition: aPosition
	self saxHandler endQuotedStringValuePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:28'!
handleEndTagPosition: aPosition
	self saxHandler endTagPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:28'!
handleEndXMLDeclarationPosition: aPosition
	self saxHandler endXMLDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
handleStartCDataPosition: aPosition
	self saxHandler startCDataPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleStartCommentPosition: aPosition
	self saxHandler startCommentPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:45'!
handleStartDeclaration: aPosition
	self saxHandler startDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
handleStartDoctypeDeclarationPosition: aPosition
	self saxHandler startDoctypeDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
handleStartEntityReferencePosition: aPosition
	self saxHandler startEntityReferencePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleStartPIPosition: aPosition
	self saxHandler startPIPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleStartQuotedStringValuePosition: aPosition
	self saxHandler startQuotedStringValuePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
handleStartTagPosition: aPosition
	self saxHandler startTagPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:25'!
handleStartXMLDeclarationPosition: aPosition
	self saxHandler startXMLDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'testing' stamp: 'monty 9/30/2015 20:45'!
isValidating
	^ false! !

!SAXPositionParserDriver methodsFor: 'private' stamp: 'monty 10/1/2015 04:35'!
tokenizerClass
	^ XMLPositionWellFormedParserTokenizer! !

XMLPrettyPrintingWriterFormatter subclass: #XMLHighlightingPrettyPrintingWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingPrettyPrintingWriterFormatter commentStamp: 'monty 3/7/2017 13:29' prior: 0!
This formatter adds highlights to pretty printed XMLHighlightingWriter output.

(Generated from XMLHighlightingWriterFormatter.)!

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 04:13'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 12/6/2015 02:10'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringValueHighlightPosition: self endPosition + 1.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 12/6/2015 02:09'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringValueHighlightPosition: self startPosition - 1.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private' stamp: 'monty 10/1/2015 04:00'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:19'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

Object subclass: #XMLExternalDocumentConverter
	instanceVariableNames: 'streamReader outputStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLExternalDocumentConverter commentStamp: 'monty 2/14/2016 04:25' prior: 0!
This class converts an external XML document  into a string with line endings normalized to CRs (the Pharo/Squeak LE) and decodes it from any of the supported character encodings and will infer incodings from byte order marks or null bytes and also consider  <?xml ...?> encoding attributes.!

!XMLExternalDocumentConverter class methodsFor: 'converting' stamp: 'monty 10/2/2015 00:11'!
convert: aStringOrStream
	^ (self on: aStringOrStream) convert! !

!XMLExternalDocumentConverter class methodsFor: 'converting' stamp: 'monty 3/13/2016 13:21'!
convert: aStringOrStream readLimit: aReadLimit
	^ (self
		on: aStringOrStream
		readLimit: aReadLimit) convert! !

!XMLExternalDocumentConverter class methodsFor: 'converting' stamp: 'monty 2/14/2016 00:06'!
convertFileNamed: aFileName
	^ (self onFileNamed: aFileName) convert! !

!XMLExternalDocumentConverter class methodsFor: 'instance creation' stamp: 'monty 10/2/2015 00:11'!
on: aStringOrStream
	^ self
		on: aStringOrStream
		readLimit: XMLParserLimits defaultReadLimit! !

!XMLExternalDocumentConverter class methodsFor: 'instance creation' stamp: 'monty 10/1/2015 05:57'!
on: aStringOrStream readLimit: aReadLimit
	^ self new
		setStream:
			(aStringOrStream isStream
				ifTrue: [aStringOrStream]
				ifFalse: [aStringOrStream readStream])
		readLimit: aReadLimit! !

!XMLExternalDocumentConverter class methodsFor: 'instance creation' stamp: 'monty 10/14/2016 22:59'!
onFileNamed: aFileName
	^ self on:
		(XMLDecodingReadStreamAdapter on:
			aFileName asXMLFileHandle rawReadStream)! !

!XMLExternalDocumentConverter methodsFor: 'closing' stamp: 'monty 10/2/2015 22:17'!
close
	streamReader closeStreams! !

!XMLExternalDocumentConverter methodsFor: 'accessing' stamp: 'monty 10/2/2015 22:18'!
contents
	^ outputStream contents! !

!XMLExternalDocumentConverter methodsFor: 'converting' stamp: 'monty 11/19/2016 19:12'!
convert
	^ self
		detectEncoding;
		nextXMLDeclaration;
		skipToEnd;
		close;
		contents! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 11/19/2016 19:12'!
detectEncoding
	streamReader detectEncoding
! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 04:51'!
expectNextAll: aString
	aString do: [:each |
		self next == each
			ifFalse: [^ nil]].
	^ aString.! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 12/2/2015 20:08'!
next
	^ streamReader next
		ifNotNil: [:nextChar |
			outputStream nextPut: nextChar.
			nextChar]! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 00:05'!
nextXMLAttributeNamed: anAttributeName
	| quote nextChar |

	self skipSeparators.
	(self expectNextAll: anAttributeName)
		ifNil: [^ nil].

	self skipSeparators.
	self next == $=
		ifFalse: [^ nil].
	self skipSeparators.

	((quote := self next) == $"
		or: [quote == $'])
		ifFalse: [^ nil].

	writeStream reset.
	[(nextChar := self next) isNil
		or: [nextChar == quote]]
		whileFalse: [writeStream nextPut: nextChar].

	nextChar
		ifNil: [^ nil]
		ifNotNil: [^ writeStream contents].! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 06:10'!
nextXMLDeclaration
	self skipSeparators.
	(self expectNextAll: '<?xml')
		ifNil: [^ self].

	self skipSeparators.
	(self nextXMLAttributeNamed: 'version')
		ifNil: [^ self].

	self skipSeparators.
	(self nextXMLAttributeNamed: 'encoding')
		ifNotNil: [:encodingName | streamReader convertFromEncoding: encodingName].! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 9/30/2015 19:21'!
peek
	^ streamReader peek! !

!XMLExternalDocumentConverter methodsFor: 'initialization' stamp: 'monty 4/1/2016 00:55'!
setStream: aStream readLimit: aReadLimit
	streamReader :=
		XMLNestedStreamReader
			on:
				(aStream isXMLConvertingStreamAdapter
					ifTrue: [aStream]
					ifFalse: [XMLDecodingReadStreamAdapter on: aStream])
			readLimit: aReadLimit.

	"this is the preferred LE char for Pharo/Squeak"
	streamReader normalizedLineEndingChar: Character cr.

	outputStream := (String new: 1024) writeStream.
	writeStream := (String new: 64) writeStream.! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 3/12/2016 19:09'!
skipSeparators
	[self peek isXMLSeparator]
		whileTrue: [self next]! !

!XMLExternalDocumentConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 22:17'!
skipToEnd
	[self next notNil] whileTrue! !

Object subclass: #XMLHighlight
	instanceVariableNames: 'color start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLHighlight commentStamp: 'monty 9/21/2015 04:24' prior: 0!
This class stores a highlight TextColor and 1-based start/end highlight positions.!

!XMLHighlight methodsFor: 'highlighting' stamp: 'monty 3/1/2017 14:32'!
applyToText: aText
	| attributeStart attributeEnd |

	"must be bounded between 1 and aText size to avoid errors if the text
	being highlighted was truncated by printString/asString"
	attributeStart := self start ifNil: [1].
	attributeEnd := (self end ifNil: [aText size]) min: aText size.
	attributeStart <= attributeEnd
		ifTrue: [
			aText
				addAttribute: self color
				from: attributeStart
				to: attributeEnd].! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
color
	^ color! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
color: aTextColor
	color := aTextColor! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
end
	^ end! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
end: anEndPosition
	end := anEndPosition! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
start
	^ start! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
start: aStartPosition
	start := aStartPosition! !

Object subclass: #XMLHighlightDefaults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

XMLHighlightDefaults class
	instanceVariableNames: 'defaultDefaultColor'!

!XMLHighlightDefaults commentStamp: 'monty 3/1/2017 18:34' prior: 0!
This is a base class for storing the default highlight TextColors used by a highlighter. It gets the initial defaults from Shout text styling.!

XMLHighlightDefaults class
	instanceVariableNames: 'defaultDefaultColor'!

XMLHighlightDefaults subclass: #XMLDocumentHighlightDefaults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

XMLDocumentHighlightDefaults class
	instanceVariableNames: 'defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLDocumentHighlightDefaults commentStamp: 'monty 3/1/2017 15:07' prior: 0!
This class stores the default highlight TextColors used by the document highlighter. It gets the initial defaults from Shout text styling.!

XMLDocumentHighlightDefaults class
	instanceVariableNames: 'defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCDataColor
	^ defaultCDataColor
		ifNil: [defaultCDataColor := self textColorForShoutProperty: #primitive]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCDataColor: aTextColor
	defaultCDataColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCommentColor
	^ defaultCommentColor
		ifNil: [defaultCommentColor :=  self textColorForShoutProperty: #comment]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultCommentColor: aTextColor
	defaultCommentColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultEntityReferenceColor
	^ defaultEntityReferenceColor
		ifNil: [defaultEntityReferenceColor := self textColorForShoutProperty: #character]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultEntityReferenceColor: aTextColor
	defaultEntityReferenceColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultPrimaryMarkupColor
	^ defaultPrimaryMarkupColor
		ifNil: [defaultPrimaryMarkupColor := self textColorForShoutProperty: #argument]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultPrimaryMarkupColor: aTextColor
	defaultPrimaryMarkupColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultQuotedStringValueColor
	^ defaultQuotedStringValueColor
		ifNil: [defaultQuotedStringValueColor := self textColorForShoutProperty: #string]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultQuotedStringValueColor: aTextColor
	defaultQuotedStringValueColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultSecondaryMarkupColor
	^ defaultSecondaryMarkupColor
		ifNil: [defaultSecondaryMarkupColor := self textColorForShoutProperty: #self]! !

!XMLDocumentHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:29'!
defaultSecondaryMarkupColor: aTextColor
	defaultSecondaryMarkupColor := aTextColor! !

!XMLDocumentHighlightDefaults class methodsFor: 'class initialization' stamp: 'monty 3/1/2017 09:39'!
initialize
	"self initialize"

	defaultDefaultColor := nil.
	defaultPrimaryMarkupColor := nil.
	defaultSecondaryMarkupColor := nil.
	defaultQuotedStringValueColor := nil.
	defaultEntityReferenceColor := nil.
	defaultCommentColor := nil.
	defaultCDataColor := nil.! !

XMLDocumentHighlightDefaults initialize!

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultDefaultColor
	^ defaultDefaultColor
		ifNil: [defaultDefaultColor := self textColorForShoutProperty: #default]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultDefaultColor: aTextColor
	defaultDefaultColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'private' stamp: 'monty 9/30/2015 20:32'!
textColorForShoutProperty: aShoutProperty
	^ TextColor color:
		(((SHTextStylerST80 new attributesFor: aShoutProperty)
			detect: [:each | each respondsTo: #color]
			ifNone: [^ nil]) color)! !

Object subclass: #XMLHighlighter
	instanceVariableNames: 'highlights defaultHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLHighlighter commentStamp: 'monty 3/1/2017 15:08' prior: 0!
This is base class for highlighters that highlight Text objects using XMLHighlights.!

XMLHighlighter subclass: #XMLDocumentHighlighter
	instanceVariableNames: 'xmlDeclarationColor doctypeDeclarationColor declarationColor piColor entityReferenceColor commentColor tagColor cdataColor quotedStringValueColor xmlDeclarationHighlight doctypeDeclarationHighlight declarationHighlight piHighlight entityReferenceHighlight commentHighlight tagHighlight cdataHighlight quotedStringValueHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLDocumentHighlighter commentStamp: 'monty 3/1/2017 15:11' prior: 0!
This class is highlighter to highlight XML document Text objects using XMLHighlights.!

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
cdataColor
	^ cdataColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
cdataColor: aTextColor
	cdataColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
commentColor
	^ commentColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
commentColor: aTextColor
	commentColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
declarationColor
	^ declarationColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
declarationColor: aTextColor
	declarationColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:30'!
defaults
	^ XMLDocumentHighlightDefaults! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
doctypeDeclarationColor
	^ doctypeDeclarationColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
doctypeDeclarationColor: aTextColor
	doctypeDeclarationColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endCDataHighlightPosition: aPosition
	self
		endHighlight: cdataHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endCommentHighlightPosition: aPosition
	self
		endHighlight: commentHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endDeclarationHighlightPosition: aPosition
	self
		endHighlight: declarationHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endDoctypeDeclarationHighlightPosition: aPosition
	self
		endHighlight: doctypeDeclarationHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endEntityReferenceHighlightPosition: aPosition
	self
		endHighlight: entityReferenceHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endPIHighlightPosition: aPosition
	self
		endHighlight: piHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endQuotedStringValueHighlightPosition: aPosition
	self
		endHighlight: quotedStringValueHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endTagHighlightPosition: aPosition
	self
		endHighlight: tagHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
endXMLDeclarationHighlightPosition: aPosition
	self
		endHighlight: xmlDeclarationHighlight
		position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
entityReferenceColor
	^ entityReferenceColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
entityReferenceColor: aTextColor
	entityReferenceColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'initialization' stamp: 'monty 3/1/2017 09:27'!
initializeColors
	super initializeColors.
	self
		xmlDeclarationColor: self defaults defaultSecondaryMarkupColor;
		doctypeDeclarationColor: self defaults defaultSecondaryMarkupColor;
		piColor: self defaults defaultSecondaryMarkupColor;
		declarationColor: self defaults defaultPrimaryMarkupColor;
		tagColor: self defaults defaultPrimaryMarkupColor;
		quotedStringValueColor: self defaults defaultQuotedStringValueColor;
		entityReferenceColor: self defaults defaultEntityReferenceColor;
		commentColor: self defaults defaultCommentColor;
		cdataColor: self defaults defaultCDataColor.! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
piColor
	^ piColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
piColor: aTextColor
	piColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
quotedStringValueColor
	^ quotedStringValueColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
quotedStringValueColor: aTextColor
	quotedStringValueColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startCDataHighlightPosition: aPosition
	cdataHighlight :=
		self
			newHighlightColor: self cdataColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startCommentHighlightPosition: aPosition
	commentHighlight :=
		self
			newHighlightColor: self commentColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startDeclarationHighlightPosition: aPosition
	declarationHighlight :=
		self
			newHighlightColor: self declarationColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startDoctypeDeclarationHighlightPosition: aPosition
	doctypeDeclarationHighlight :=
		self
			newHighlightColor: self doctypeDeclarationColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startEntityReferenceHighlightPosition: aPosition
	entityReferenceHighlight :=
		self
			newHighlightColor: self entityReferenceColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startPIHighlightPosition: aPosition
	piHighlight :=
		self
			newHighlightColor: self piColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startQuotedStringValueHighlightPosition: aPosition
	quotedStringValueHighlight :=
		self
			newHighlightColor: self quotedStringValueColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startTagHighlightPosition: aPosition
	tagHighlight :=
		self
			newHighlightColor: self tagColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 2/27/2017 17:17'!
startXMLDeclarationHighlightPosition: aPosition
	xmlDeclarationHighlight :=
		self
			newHighlightColor: self xmlDeclarationColor
			position: aPosition! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
tagColor
	^ tagColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
tagColor: aTextColor
	tagColor := aTextColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
xmlDeclarationColor
	^ xmlDeclarationColor! !

!XMLDocumentHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:16'!
xmlDeclarationColor: aTextColor
	xmlDeclarationColor := aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:22'!
defaultColor
	^ defaultHighlight color! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:22'!
defaultColor: aTextColor
	defaultHighlight color: aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 2/27/2017 17:24'!
defaults
	self subclassResponsibility! !

!XMLHighlighter methodsFor: 'private' stamp: 'monty 10/1/2015 03:29'!
endHighlight: aHighlightOrNil position: aPosition
	aHighlightOrNil
		ifNotNil: [aHighlightOrNil end: aPosition]! !

!XMLHighlighter methodsFor: 'highlighting' stamp: 'monty 10/1/2015 04:06'!
highlightText: aText
	highlights do: [:each | each applyToText: aText]! !

!XMLHighlighter methodsFor: 'highlighting' stamp: 'monty 10/2/2015 02:11'!
highlightText: aText withColor: aTextColor startingAt: aPosition
	XMLHighlight new
		color: aTextColor;
		start: aPosition;
		applyToText: aText! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 2/27/2017 17:25'!
initialize
	super initialize.

	self
		initializeHighlights;
		initializeColors.! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 2/27/2017 17:24'!
initializeColors
	self defaultColor: self defaults defaultDefaultColor! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 2/27/2017 17:25'!
initializeHighlights
	defaultHighlight := XMLHighlight new.
	highlights := OrderedCollection with: defaultHighlight.! !

!XMLHighlighter methodsFor: 'private' stamp: 'monty 10/1/2015 03:41'!
newHighlightColor: aTextColor position: aPosition
	^ aTextColor
		ifNotNil: [
			highlights addLast:
				(XMLHighlight new
					color: aTextColor;
					start: aPosition)]! !

XMLCanonicalWriterFormatter subclass: #XMLHighlightingCanonicalWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingCanonicalWriterFormatter commentStamp: 'monty 3/7/2017 13:29' prior: 0!
This formatter adds highlights to canonical XMLHighlightingWriter output.

(Generated from XMLHighlightingWriterFormatter.)!

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'private' stamp: 'monty 3/7/2017 13:11'!
endPosition
	^ self writer position! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringValueHighlightPosition: self endPosition + 1.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringValueHighlightPosition: self startPosition - 1.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:11'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'private' stamp: 'monty 3/7/2017 13:11'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingCanonicalWriterFormatter methodsFor: 'accessing' stamp: 'monty 3/7/2017 13:11'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

XMLWriterFormatter subclass: #XMLHighlightingWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingWriterFormatter commentStamp: 'monty 3/7/2017 13:29' prior: 0!
This formatter adds highlights to XMLHighlightingWriter output.!

!XMLHighlightingWriterFormatter class methodsFor: 'private' stamp: 'monty 3/7/2017 13:29'!
generateHighlightingSubclassOf: aFormatterClass named: aName inCategory: aCategory
	| newSubclass |

	(aFormatterClass == self
		or: [aFormatterClass class inheritsFrom: self])
		ifTrue: [
			^ aFormatterClass
				subclass: aName asSymbol
				instanceVariableNames: ''
				classVariableNames: ''
				category: aCategory asSymbol].

	newSubclass :=
		aFormatterClass
			subclass: aName asSymbol
			instanceVariableNames: 'highlighter'
			classVariableNames: ''
			category: aCategory asSymbol.
	self selectors do: [:each |
		newSubclass
			compile: (self sourceCodeAt: each)
			classified: (self whichCategoryIncludesSelector: each)].

	^ newSubclass.! !

!XMLHighlightingWriterFormatter methodsFor: 'private' stamp: 'monty 3/7/2017 13:03'!
endPosition
	^ self writer position! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringValueHighlightPosition: self endPosition + 1.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringValueHighlightPosition: self startPosition - 1.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'formatting' stamp: 'monty 3/7/2017 13:02'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingWriterFormatter methodsFor: 'private' stamp: 'monty 3/7/2017 13:03'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingWriterFormatter methodsFor: 'accessing' stamp: 'monty 3/7/2017 13:02'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

!XMLDeclarationNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ false! !

!ZnStringEntity methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 5/8/2015 23:03'!
gtInspectorXmlIn: composite
	<gtInspectorPresentationOrder: 40>
	| xml |
	xml := [XMLDOMParser parse: self string]
		on: XMLParserException
		do: [ ^ self ].
	(xml gtInspectorTreeIn: composite)
		title: 'XML'! !

!XMLAttribute methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ false! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/2/2017 06:17'!
gtInspectorXMLFileIn: aComposite
	<gtInspectorPresentationOrder: 4>

	| xmlFileHandle currentTextStylerDecorator |

	xmlFileHandle := XMLFileSystemFileHandle fileReference: self.
	xmlFileHandle isXMLDocumentFile
		ifFalse: [^ self].

	aComposite custom:
		(GLMRubricHighlightedTextPresentation new
			title: 'Source';
			editingMode: [
				"saved to get the encoding later"
				currentTextStylerDecorator :=
					GLMXMLDocumentHighlighterTextStylerDecorator new.
				GLMHighlighterTextRubEditingMode withStylerDecorator:
					currentTextStylerDecorator];
			display: [
				XMLExternalDocumentConverter convert: xmlFileHandle rawReadStream];
			withLineNumbers: true;
			act: [:presentation | | sourceToSave streamConverter |
				sourceToSave := presentation text asString.
				streamConverter :=
					currentTextStylerDecorator hasEncoding
						ifTrue: [currentTextStylerDecorator encoding asXMLStreamConverter]
						ifFalse: [XMLStreamConverter default].
				xmlFileHandle writeStreamDo: [:writeStream |
					writeStream
						streamConverter: streamConverter;
						nextPutByteOrderMark;
						nextPutAll: sourceToSave].
				presentation clearUserEdits]
				icon: GLMUIThemeExtraIcons glamorousSave
				on: $s
				entitled: 'Save').! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/13/2016 16:39'!
spotterForXMLFileFor: aStep
	<spotterOrder: 40>

	| xmlFileHandle |

	xmlFileHandle := XMLFileSystemFileHandle fileReference: self.
	xmlFileHandle isXMLDocumentFile
		ifFalse: [^ self].

	aStep listProcessor
		title: 'XML Document';
		allCandidates: [
			(XMLDOMParser parse: xmlFileHandle rawReadStream) allElements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true.! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/5/2017 15:50'!
spotterPreviewXMLFileIn: aComposite
	<spotterPreview: 10>

	| xmlFileHandle |

	xmlFileHandle := XMLFileSystemFileHandle fileReference: self.
	xmlFileHandle isXMLDocumentFile
		ifFalse: [^ self].

	aComposite text
		title: 'Source';
		display: [
			"the source is converted to a decoded string and then highlighted"
			XMLHighlightingParser parse:
				(XMLExternalDocumentConverter convert: xmlFileHandle rawReadStream)];
		entity: self.! !

GLMRubricHighlightedTextPresentation subclass: #GLMXMLDisabledRubricHighlightedTextPresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLDisabledRubricHighlightedTextPresentation commentStamp: 'monty 3/5/2017 13:03' prior: 0!
A disabled version of the superclass.!

!GLMXMLDisabledRubricHighlightedTextPresentation methodsFor: 'rendering' stamp: 'monty 3/5/2017 12:33'!
renderGlamorouslyOn: aRenderer
	^ (super renderGlamorouslyOn: aRenderer)
		beReadOnly;
		yourself! !

!XMLNodeWithElements class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode nodes! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:18'!
addTreeViewChildrenTo: aSequenceableCollection
	self nodesDo: [:each |
		(each isStringNode
			and: [each isEmpty
				or: [each isWhitespace]])
			ifFalse: [aSequenceableCollection addLast: each]]! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:12'!
requiresTreeView
	^ self hasChildren
		and: [self nodes size > 1
			or: [self firstNode isStringNode not]]! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 06:03'!
spotterForAllElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'All elements';
		allCandidates: [self allElements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 06:03'!
spotterForDirectElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'Direct elements';
		allCandidates: [self elements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 23:16'!
spotterPreviewSourceIn: aComposite
	<spotterPreview: 10>
	
	aComposite text
		title: 'Source';
		display: [
			self asHighlightedTextWrittenWith: [:writer |
				"use less indent for spotter previews"
				writer formatter indentString: '  '.
				self writeXMLOn: writer]];
		entity: self! !

XMLWriter subclass: #XMLHighlightingWriter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingWriter commentStamp: 'monty 10/1/2015 04:20' prior: 0!
This class is an XMLWriter that can make highlighted text output with XMLHighlightingPrettyPrintingWriterFormatter and XMLHighlighter.!

!XMLHighlightingWriter methodsFor: 'converting' stamp: 'monty 3/6/2016 09:05'!
asHighlightedText
	| text |

	"printString/asString forward to printStringLimitedTo: which truncates,
	so contents is used instead to get the complete text"
	text := self contents asText.
	self highlighter highlightText: text.
	^ text.! !

!XMLHighlightingWriter methodsFor: 'private' stamp: 'monty 3/7/2017 13:25'!
canonicalWriterFormatterClass
	^ XMLHighlightingCanonicalWriterFormatter! !

!XMLHighlightingWriter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:19'!
highlighter
	^ highlighter! !

!XMLHighlightingWriter methodsFor: 'initialization' stamp: 'monty 3/7/2017 13:24'!
initialize
	super initialize.

	highlighter := XMLDocumentHighlighter new.
	self formatter: XMLHighlightingWriterFormatter new.! !

!XMLHighlightingWriter methodsFor: 'private' stamp: 'monty 3/7/2017 13:24'!
prettyPrintingWriterFormatterClass
	^ XMLHighlightingPrettyPrintingWriterFormatter! !

XMLWellFormedParserTokenizer subclass: #XMLPositionWellFormedParserTokenizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLPositionWellFormedParserTokenizer commentStamp: 'monty 3/6/2016 08:18' prior: 0!
This class is a tokenizer for well-formed XML that tracks token start/end positions. Does not support entities or validation.!

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:35'!
nextAttributeValue
	| attributeValue |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	attributeValue := super nextAttributeValue.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ attributeValue.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:36'!
nextCDataSection
	driver handleStartCDataPosition: self currentPosition - 1.
	super nextCDataSection.
	driver handleEndCDataPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/6/2016 07:19'!
nextCharacterReferenceOnCharacterDataStream
	| result |

	driver handleStartEntityReferencePosition: self currentPosition.
	result := super nextCharacterReferenceOnCharacterDataStream.
	driver handleEndEntityReferencePosition: self currentPosition.

	^ result.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:36'!
nextComment
	driver handleStartCommentPosition: self currentPosition - 1.
	super nextComment.
	driver handleEndCommentPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:37'!
nextDoctypeDeclaration
	driver handleStartDoctypeDeclarationPosition: self currentPosition - 1.
	super nextDoctypeDeclaration.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:37'!
nextEndDoctypeDeclaration
	super nextEndDoctypeDeclaration.
	driver handleEndDoctypeDeclarationPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:37'!
nextEntityValue
	| entityValue |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	entityValue := super nextEntityValue.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ entityValue.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 11/6/2016 07:20'!
nextGeneralEntityReferenceOnCharacterDataStream
	driver handleStartEntityReferencePosition: self currentPosition.
	self nextName.
	driver handleEndEntityReferencePosition: self currentPosition + 1.
	self expectNext: $;.

	^ false.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:37'!
nextPIWithTarget: aTarget
	driver handleStartPIPosition: self currentPosition - (aTarget size + 1).
	super nextPIWithTarget: aTarget.
	driver handleEndPIPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:38'!
nextParameterEntityReference
	driver handleStartEntityReferencePosition: self currentPosition.
	self nextName.
	driver handleEndEntityReferencePosition: self currentPosition + 1.
	self expectNext: $;.
	^ false.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/1/2015 05:11'!
nextParameterEntityReferenceInDeclaration
	^ self nextParameterEntityReference! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 11/6/2016 07:30'!
nextParameterEntityReferenceOnCharacterDataStream
	^ self nextParameterEntityReference! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:38'!
nextPublicIDLiteral
	| publicID |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	publicID := super nextPublicIDLiteral.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ publicID.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:47'!
nextSubsetDeclaration
	driver handleStartDeclaration: self currentPosition - 1.
	super nextSubsetDeclaration.
	driver handleEndDeclaration: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 3/19/2016 00:43'!
nextSystemIDLiteral
	| systemID |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	systemID := super nextSystemIDLiteral.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ systemID.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/30/2016 04:11'!
nextSystemIDLiteralWithoutURIFragment
	| systemID |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	systemID := super nextSystemIDLiteralWithoutURIFragment.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ systemID.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:35'!
nextTag
	driver handleStartTagPosition: self currentPosition.
	super nextTag.
	driver handleEndTagPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:39'!
nextXMLDeclaration
	driver handleStartXMLDeclarationPosition: self currentPosition - 4. "'<?xml' size"
	super nextXMLDeclaration.
	driver handleEndXMLDeclarationPosition: self currentPosition.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:39'!
nextXMLEncodingAttributeValue
	| encoding |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	encoding := super nextXMLEncodingAttributeValue.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ encoding.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:39'!
nextXMLStandaloneAttributeValue
	| yesOrNo |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	yesOrNo := super nextXMLStandaloneAttributeValue.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ yesOrNo.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 3/19/2016 00:39'!
nextXMLVersionAttributeValue
	| version |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	version := super nextXMLVersionAttributeValue.
	driver handleEndQuotedStringValuePosition: self currentPosition.

	^ version.! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:35'!
addOrderedListTableToComposite: aComposite paneTitle: aPaneTitle columnTitle: aColumnTitle
	"Adapted from SequenceableCollection>>gtInspectorItemsIn:"
	^ aComposite table
		title: aPaneTitle;
		display: [:aCollection |
			(1 to: self size) collect: [:i | i -> (self at: i)]];
		beMultiple;
		searchOn: [:text :each | 
			Behavior compilerClass
				evaluate: ' | entity each | each := self. entity := each.', text
				for: each value
				logged: false];
		column: 'Index' evaluated: [:assoc |
			self orderedListTableDisplayKeyFrom: assoc key];
		column: aColumnTitle evaluated: [:assoc |
			self orderedListTableDisplayValueFrom: assoc value];
		send: [:result |
			result ifNotNil: [
				result value size = 1 
					ifTrue: [result anyOne value]
					ifFalse: [
						self species withAll:
							(result collect: [:each | each value])]]];
		showOnly: 50;
		helpMessage:
			'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:31'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Index'
		columnTitle: 'Item'! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:35'!
orderedListTableDisplayKeyFrom: aKey
	^ aKey printString! !

!XMLOrderedList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/1/2017 15:35'!
orderedListTableDisplayValueFrom: aValue
	"this may be overrided in the future in subclasses to return
	highlighted text objects when GT tables support it"
	^ aValue printString! !

GLMHighlighterTextStylerDecorator subclass: #GLMXMLHighlighterTextStylerDecorator
	instanceVariableNames: 'highlightableLengthLimit errorColor encoding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLHighlighterTextStylerDecorator commentStamp: 'monty 3/4/2017 13:05' prior: 0!
An abstract base class for XML highlighter text styler decorators. Subclasses need to implement #highlightingParse:onSuccess:onError: .!

GLMXMLHighlighterTextStylerDecorator subclass: #GLMXMLDocumentHighlighterTextStylerDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLDocumentHighlighterTextStylerDecorator commentStamp: 'monty 3/4/2017 13:05' prior: 0!
A highlighting XML document text style decorator.!

GLMXMLDocumentHighlighterTextStylerDecorator subclass: #GLMXMLDisabledDocumentHighlighterTextStylerDecorator
	instanceVariableNames: 'disabledText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator class methodsFor: 'instance creation' stamp: 'monty 3/5/2017 15:49'!
disabledText: aStringOrText
	^ self new disabledText: aStringOrText! !

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2017 15:49'!
disabledText
	^ disabledText ifNil: [disabledText := '' asText]! !

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2017 15:49'!
disabledText: aStringOrText
	disabledText := aStringOrText asText! !

!GLMXMLDisabledDocumentHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 3/5/2017 15:50'!
parse: aString onError: anError
	^ self disabledText! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/5/2017 15:40'!
highlightingParse: aString onSuccess: aOneArgumentBlock onError: aTwoArgumentBlock
	| highlightingParserHandler highlightingParser |

	highlightingParserHandler := self newHighlightingParserHandlerOn: aString.
	highlightingParser := self newHighlightingParserFromHandler: highlightingParserHandler.
	[highlightingParser parseDocument]
		on: XMLParserException
		do: [:error |
			^ aTwoArgumentBlock
				value: highlightingParserHandler
				value: highlightingParser currentPosition].
	^ aOneArgumentBlock value: highlightingParserHandler.! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/5/2017 15:43'!
newHighlightingParserFromHandler: aHighlightingParserHandler
	^ aHighlightingParserHandler parser! !

!GLMXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/5/2017 15:50'!
newHighlightingParserHandlerOn: aString
	^ XMLHighlightingParser on: aString! !

GLMXMLDocumentHighlighterTextStylerDecorator subclass: #GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator
	instanceVariableNames: 'outerXMLNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator class methodsFor: 'private' stamp: 'monty 3/5/2017 15:43'!
outerXMLNode: aNode
	^ self new outerXMLNode: aNode! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/10/2017 14:25'!
newHighlightingParserFromHandler: aHighlightingParserHandler
	| parser rootElement context |

	parser := super newHighlightingParserFromHandler: aHighlightingParserHandler.

	self outerXMLNode document
		ifNotNil: [:document |
			parser driver isStandalone: document isStandalone.
			document hasDoctypeDefinition
				ifTrue: [
					parser driver doctypeDefinition
						addGeneralEntitiesFrom: document doctypeDefinition]].

	self outerXMLNode isElement
		ifTrue: [rootElement := self outerXMLNode]
		ifFalse: [
			(self outerXMLNode hasParent
				and: [self outerXMLNode parent isElement])
				ifTrue: [rootElement := self outerXMLNode parent]].
	rootElement
		ifNotNil: [
			parser driver currentElement: rootElement name.
			rootElement hasNamespaces
				ifTrue: [parser driver currentScope: rootElement namespaceScope]].

	(context := self outerXMLNode parent newInnerXMLContext) isContentContext
		ifTrue: [aHighlightingParserHandler startContent].
	parser context: context.

	^ parser.! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/5/2017 15:43'!
newHighlightingParserHandlerOn: aString
	^ (super newHighlightingParserHandlerOn: aString)
		configuration: self outerXMLNode configuration copy! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2017 15:43'!
outerXMLNode
	^ outerXMLNode! !

!GLMXMLOuterXMLDocumentHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2017 15:43'!
outerXMLNode: aNode
	outerXMLNode := aNode! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/1/2015 21:52'!
defaultStyler
	^ GLMHighlighterTextParserStyler new
		view: self;
		parser: self! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 3/5/2016 07:10'!
encoding
	^ encoding! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:11'!
errorColor
	^ errorColor! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:12'!
errorColor: aTextColor
	errorColor := aTextColor! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'testing' stamp: 'monty 10/3/2016 17:08'!
hasEncoding
	^ self encoding notEmpty! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:11'!
highlightableLengthLimit
	^ highlightableLengthLimit! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:08'!
highlightableLengthLimit: aLimit
	highlightableLengthLimit := aLimit! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/2/2017 06:15'!
highlightingParse: aString onSuccess: aOneArgumentBlock onError: aTwoArgumentBlock
	self subclassResponsibility! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'initialization' stamp: 'monty 3/5/2016 07:10'!
initialize
	super initialize.

	highlightableLengthLimit := 100000.
	errorColor := TextColor red.
	encoding := ''.! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 3/2/2017 06:14'!
parse: aString onError: anError
	| highlightedText |

	aString size > self highlightableLengthLimit
		ifTrue: [^ aString asText].

	self
		highlightingParse: aString
		onSuccess: [:highlightingParser |
			highlightedText := highlightingParser asHighlightedText.
			encoding := highlightingParser encoding]
		onError: [:highlightingParser :position |
			highlightedText :=
				highlightingParser
					asHighlightedTextWithRemainderColored: self errorColor
					startingAt:
						(position >= aString size
							ifTrue: [1]
							ifFalse: [position]).
			encoding := highlightingParser encoding].

	^ highlightedText.! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 10/1/2015 21:54'!
parser
	^ self! !

SAXHandler subclass: #SAXPositionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!SAXPositionHandler commentStamp: 'monty 10/2/2015 04:56' prior: 0!
This class is a SAXHandler that can track the positions of tokens. Does not support validation or entity replacement but can check wellformedness and namespaces.!

!SAXPositionHandler methodsFor: 'private' stamp: 'monty 10/1/2015 04:26'!
driverClass
	^ SAXPositionParserDriver! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
endCDataPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
endCommentPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
endDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
endDoctypeDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
endEntityReferencePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
endPIPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
endQuotedStringValuePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:27'!
endTagPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:27'!
endXMLDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
startCDataPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
startCommentPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
startDoctypeDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
startEntityReferencePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
startPIPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
startQuotedStringValuePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
startTagPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
startXMLDeclarationPosition: aPosition! !

SAXPositionHandler subclass: #XMLHighlightingParser
	instanceVariableNames: 'highlighter encoding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLHighlightingParser commentStamp: 'monty 3/6/2016 08:22' prior: 0!
This class is an XML parser that can convert its input to Text objects styled with highlighting after parsing.!

!XMLHighlightingParser methodsFor: 'converting' stamp: 'monty 3/1/2017 18:32'!
asHighlightedText
	| text |

	text := self input asString asText.
	highlighter highlightText: text.
	^ text.! !

!XMLHighlightingParser methodsFor: 'converting' stamp: 'monty 10/2/2015 02:11'!
asHighlightedTextWithRemainderColored: aTextColor startingAt: aPosition
	| text |

	text := self asHighlightedText.
	highlighter
		highlightText: text
		withColor: aTextColor
		startingAt: aPosition.
	^ text.! !

!XMLHighlightingParser methodsFor: 'accessing' stamp: 'monty 3/5/2016 07:09'!
encoding
	^ encoding! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endCDataPosition: aPosition
	highlighter endCDataHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endCommentPosition: aPosition
	highlighter endCommentHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endDeclarationPosition: aPosition
	highlighter endDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endDoctypeDeclarationPosition: aPosition
	highlighter endDoctypeDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endEntityReferencePosition: aPosition
	highlighter endEntityReferenceHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endPIPosition: aPosition
	highlighter endPIHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endQuotedStringValuePosition: aPosition
	highlighter endQuotedStringValueHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endTagPosition: aPosition
	highlighter endTagHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endXMLDeclarationPosition: aPosition
	highlighter endXMLDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'accessing' stamp: 'monty 10/1/2015 04:50'!
highlighter
	^ highlighter! !

!XMLHighlightingParser methodsFor: 'initialization' stamp: 'monty 2/27/2017 17:19'!
on: aStringOrStream
	super on: aStringOrStream.

	highlighter := XMLDocumentHighlighter new.
	encoding := ''.! !

!XMLHighlightingParser methodsFor: 'parsing' stamp: 'monty 10/1/2015 22:22'!
parsingResult
	^ self asHighlightedText! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
startCDataPosition: aPosition
	highlighter startCDataHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startCommentPosition: aPosition
	highlighter startCommentHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
startDeclarationPosition: aPosition
	highlighter startDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startDoctypeDeclarationPosition: aPosition
	highlighter startDoctypeDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:48'!
startEntityReferencePosition: aPosition
	highlighter startEntityReferenceHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startPIPosition: aPosition
	highlighter startPIHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startQuotedStringValuePosition: aPosition
	highlighter startQuotedStringValueHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:48'!
startTagPosition: aPosition
	highlighter startTagHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startXMLDeclarationPosition: aPosition
	highlighter startXMLDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - lexical' stamp: 'monty 3/5/2016 07:09'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	encoding := anEncoding! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/10/2017 14:08'!
addTreeViewChildrenTo: aSequenceableCollection
	self nodesDo: [:each |
		aSequenceableCollection addLast: each]! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/16/2016 13:01'!
requiresTreeView
	^ self hasChildren! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/10/2017 14:08'!
treeViewChildren
	self requiresTreeView
		ifTrue: [| treeViewChildren |
			treeViewChildren := OrderedCollection new: self nodes size.
			self addTreeViewChildrenTo: treeViewChildren.
			^ treeViewChildren]
		ifFalse: [^ #()]! !

!XMLInternalSubsetList methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/13/2015 13:19'!
gtInspectorItemsIn: aComposite
	^ self
		addOrderedListTableToComposite: aComposite
		paneTitle: 'Nodes'
		columnTitle: 'Node'! !

!XMLDoctypeDeclaration methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 09:29'!
supportsSourceEditing
	^ false! !

!XMLDoctypeDeclaration methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 3/7/2017 13:31'!
writeTreeViewLabelXMLOn: aWriter
	aWriter doctype
		root: self root;
		publicID: self publicID;
		systemID: self systemID;
		write! !

XMLDocumentHighlightDefaults initialize!
